#ifndef __BNODE_H
#define __BNODE_H

// ==========================================================
//  AUTHOR:  R.P. Wiegand        CREATED: 14-Mar-06
// ----------------------------------------------------------
//  This module provides the class definition for the class
// that implements a basic binary tree node.  
// ==========================================================


class bnode 
{
 public:
  bnode();
  bnode(int iKey);
  bnode(bnode *iLeft, bnode *iRight, bnode *iParent, 
         int iKey);
  ~bnode();

  // Methods for quasi-safe linking of pointers
  void linkLeft  (bnode *x, int upLink = 1);
  void linkRight (bnode *x, int upLink = 1);
  void linkParent(bnode *x);
  void linkFull  (bnode *left, bnode *right, bnode *parent);
  void linkSubs  (bnode *y);

  // Accessor methods
  void   setKey(int iKey)    {if (iKey > 0) mKey = iKey;}
  int    getKey()             {return(mKey);}
  bnode *Left()              {return(pLeft);}
  bnode *Right()             {return(pRight);}
  bnode *Parent()            {return(pParent);}

  // Methods for dealing the the compare count global
  static void resetCompareCount();
  static int  getCompareCount();  
  int  compareKeys(bnode *x);
  int  compareKeys(int iKey);


 protected:
  bnode *pLeft;
  bnode *pRight;
  bnode *pParent;
  int     mKey;

  void defaultNode();
};

#define NIL (bnode *)0


#endif
