#ifndef __BTREE_H
#define __BTREE_H

#include "bnode.h"

// ==========================================================
//  AUTHOR:  R.P. Wiegand        CREATED: 14-Mar-06
// ----------------------------------------------------------
//  This module provides the class definition for the class
// that implements a basic binary tree.  
// ==========================================================

class btree
{
public:
  btree();
  ~btree();
  
  // Basic Tree Operations
  void   insert(bnode *x);  
  void   insert(int iKey);
  bnode *search(int iKey);

  // Some helpful convenience functions
  int  getNodeCount() {return(mNodeCount);}
  void printTree();

  static void test();
  

protected:
  bnode *pRoot;
  int    mNodeCount;
  
  void    truePrintTree(bnode *curr, int level);
  void    printNode(int level, bnode *x);
};

  
#endif
