#!/bin/sh

#
# Generate an error of there are fewer than 3 command line arguments
#
if [ $# -lt 3 ] ; then
  echo "$0 takes 3 arguments:  max data size, max data range, and data directory name!"
  echo " "
  exit
fi


#
# Prepare the data files
#
cd $3
rm -f bin-$1-$2.final


#
# Create .final files for Binary tree
#
echo "Collating Binary tree data..."
cat bin-$1-$2-*.out | grep "INSERT:" | cut -f2 -d" "> bin-tmp1.out
cat bin-$1-$2-*.out | grep "SEARCH:" | cut -f2 -d" "> bin-tmp2.out
paste bin-tmp1.out bin-tmp2.out >> bin-$1-$2.final


#
# Remove unnecssary temporary files
#
echo "Removing temporary files..."
rm bin-tmp*.out


echo "--------------------------------------------------"
echo "Collated results placed in $3/bin-$1-$2.final"
echo "  - Column 1 are the comparison counts for insert"
echo "  - Column 2 are the comparison counts for search"
echo "  - Each row is a separate trial with a different"
echo "    data set of size $1"
echo "--------------------------------------------------"

